/*********************************************
 * OPL 12.6.2.0 Model
 * Author: Lenovo
 * Creation Date: Jun 15, 2016 at 4:29:05 PM
 *********************************************/
int NbGroups=...;
int NbProducts=...;
int NbClasses=...;
int Capacity=...;
int GrCapacity=...;
range Groups=1..NbGroups;
range Products=1..NbProducts;
range Classes=1..NbClasses;
float Preference[Classes][Products] = ...;
int   PreferenceRank[Classes][Products] = ...;
float Prices[Products]=...;
float Space[Products]=...;
int   Rank[Classes][Products]=...;
int   Group[Products]=...;
float spacetemp=...;
int grtemp[Groups]=...;
float v0[Classes]=...;
float lambda[Classes]=...;
float PriceMax=...;
dvar float+ w[Classes];
dvar float+ y[Classes];
dvar float+ z[Classes][Products];
dvar boolean x[Products];
float LB1_notin[Classes][Products];
float LB1_in[Classes][Products];
float LB2_notin[Classes][Products];
float LB2_in[Classes][Products];
float LB_notin[Classes][Products];
float LB_in[Classes][Products];

execute INITIALIZE {
for (i in Classes) {
  for (j in Products) {
    LB1_in[i][j]=Preference[i][j];
    spacetemp=Space[j];
    for(k=1; k<=NbProducts;k++ ) {
     if (j!=Rank[i][k]){  
         if (Space[Rank[i][k]]+spacetemp<=Capacity) {
             LB1_in[i][j]=LB1_in[i][j]+Preference[i][Rank[i][k]];
             spacetemp=spacetemp+  Space[Rank[i][k]];}
         else {
             LB1_in[i][j]=LB1_in[i][j]+Preference[i][Rank[i][k]]*(Capacity-spacetemp)/Space[Rank[i][k]];
             spacetemp=Capacity;}     
   }
  }
}
}

for (i in Classes) {
  for (j in Products){ 
  spacetemp=0;
  for(k=1; k<=NbProducts;k++ ) {
     if (j!=Rank[i][k]){  
       if (Space[Rank[i][k]]+spacetemp<=Capacity) {
          LB1_notin[i][j]=LB1_notin[i][j]+Preference[i][Rank[i][k]];
          spacetemp=spacetemp+  Space[Rank[i][k]];}
       else {
          LB1_notin[i][j]=LB1_notin[i][j]+Preference[i][Rank[i][k]]*(Capacity-spacetemp)/Space[Rank[i][k]];
          spacetemp=Capacity;}     
     }  
   }   
  }
}

for (i in Classes) {
  for (j in Products) {
    for (u in Groups)
      grtemp[u]=0;  
    LB2_in[i][j]=Preference[i][j];
    grtemp[Group[j]]=1;
    for (k=1; k<=NbProducts;k++){
    if (j!=PreferenceRank[i][k]){
      if (grtemp[Group[PreferenceRank[i][k]]]<GrCapacity){
         LB2_in[i][j]=LB2_in[i][j]+Preference[i][PreferenceRank[i][k]];
         grtemp[Group[PreferenceRank[i][k]]]=grtemp[Group[PreferenceRank[i][k]]]+1;   
    }}
}
}
}

for (i in Classes) {
  for (j in Products) {
    for (u in Groups)
      grtemp[u]=0;  
    LB2_notin[i][j]=0;
    for (k=1; k<=NbProducts;k++){
    if (j!=PreferenceRank[i][k]){
      if (grtemp[Group[PreferenceRank[i][k]]]<GrCapacity){
         LB2_notin[i][j]=LB2_notin[i][j]+Preference[i][PreferenceRank[i][k]];
         grtemp[Group[PreferenceRank[i][k]]]=grtemp[Group[PreferenceRank[i][k]]]+1;   
    }}
}
}
}



for (i in Classes) {
  for (j in Products) {
    if (LB1_in[i][j]<LB2_in[i][j])
       LB_in[i][j]=LB1_in[i][j];
    if (LB1_in[i][j]>=LB2_in[i][j])
       LB_in[i][j]=LB2_in[i][j];     
    if (LB1_notin[i][j]<LB2_notin[i][j])
       LB_notin[i][j]=LB1_notin[i][j];
    if (LB1_notin[i][j]>=LB2_notin[i][j])
       LB_notin[i][j]=LB2_notin[i][j];    
  }
}

}

// CONIC-MC Formulation
/* minimize sum(i in Classes)PriceMax*lambda[i]*v0[i]*y[i]+sum(i in Classes,j in Products)lambda[i]*(PriceMax-Prices[j])*Preference[i][j]*z[i][j];
 subject to {
 forall(i in Classes)
    w[i]*y[i]>=1;
forall(i in Classes, j in Products)
    z[i][j]*w[i]>=x[j]^2;
forall(i in Classes)
    w[i]==sum(j in Products)Preference[i][j]*x[j]+v0[i];
sum(j in Products)Space[j]*x[j]<=Capacity;
forall(k in Groups)
  sum(j in Products:Group[j]==k) x[j]<=GrCapacity;   
forall(i in Classes, j in Products)
  z[i][j]<=x[j]/(v0[i]+Preference[i][j]);
forall(i in Classes, j in Products)
  z[i][j]>=(1/(v0[i]+LB_in[i][j]))*x[j];
forall(i in Classes, j in Products)
  z[i][j]<=y[i]-(1/(v0[i]+LB_notin[i][j]))*(1-x[j]);
forall(i in Classes, j in Products)
  z[i][j]>=y[i]-(1/v0[i])*(1-x[j]);    
forall(i in Classes)
  v0[i]*y[i]+sum(j in Products)Preference[i][j]*z[i][j]>=1;
}
*/

// MILP-MC Formulation
/* 
 maximize sum(i in Classes, j in Products)lambda[i]*Prices[j]*Preference[i][j]*z[i][j];
subject to {
sum(j in Products)Space[j]*x[j]<=Capacity;
forall(k in Groups)
  sum(j in Products:Group[j]==k) x[j]<=GrCapacity; 
forall(i in Classes)
  v0[i]*y[i]+sum(j in Products)Preference[i][j]*z[i][j]==1;
forall(i in Classes, j in Products)
  z[i][j]<=x[j]/(v0[i]+Preference[i][j]);
forall(i in Classes, j in Products)
  z[i][j]>=(1/(v0[i]+LB_in[i][j]))*x[j];
forall(i in Classes, j in Products)
  z[i][j]<=y[i]-(1/(v0[i]+LB_notin[i][j]))*(1-x[j]);
forall(i in Classes, j in Products)
  z[i][j]>=y[i]-(1/v0[i])*(1-x[j]);        
}
*/

// MILP Formulation

/*
 maximize sum(i in Classes, j in Products)lambda[i]*Prices[j]*Preference[i][j]*z[i][j];
subject to {
sum(j in Products)Space[j]*x[j]<=Capacity;
forall(k in Groups)
  sum(j in Products:Group[j]==k) x[j]<=GrCapacity; 
forall(i in Classes)
  v0[i]*y[i]+sum(j in Products)Preference[i][j]*z[i][j]==1;
forall(i in Classes, j in Products)
  v0[i]*(y[i]-z[i][j])<=1-x[j];
forall(i in Classes, j in Products)
  z[i][j]<=y[i];
forall(i in Classes, j in Products)
  v0[i]*z[i][j]<=x[j];          
}
*/

// CONIC Formulation

 minimize sum(i in Classes)PriceMax*lambda[i]*v0[i]*y[i]+sum(i in Classes,j in Products)lambda[i]*(PriceMax-Prices[j])*Preference[i][j]*z[i][j];
 subject to {
 sum(j in Products)Space[j]*x[j]<=Capacity;
 forall(k in Groups)
   sum(j in Products:Group[j]==k) x[j]<=GrCapacity; 
 forall(i in Classes)
    w[i]*y[i]>=1;
 forall(i in Classes, j in Products)
    z[i][j]*w[i]>=x[j]^2;
 forall(i in Classes)
    w[i]==sum(j in Products)Preference[i][j]*x[j]+v0[i];
forall(i in Classes)
  v0[i]*y[i]+sum(j in Products)Preference[i][j]*z[i][j]>=1;
}
 